 
;----------- SCREEN 1 ------------------------------
PNT	 EQU #1800	; начало таблицы имен шаблонов
CT	 EQU #2000	; начало таблицы цветов
PGT  EQU #0000	; начало таблицы шаблонов 
SAT	 EQU #1B00
SGT	 EQU #3800
SPRITE_SIZE		EQU #02	; 16x16
;---------------------------------------------------

	org #100

	di
	ld sp,newsp
	call SET_SCREEN1
    ld   hl,interrupt_routine
    ld   (#0039),hl

	ld a,PUSTO_PUSTO
	ld (#8000),a
	ld a,PUSTO_NET
	ld (#8001),a
	ld a,NET_NET
	ld (#8101),a
	ld a,NET_PUSTO
	ld (#8100),a
	
	call CLS_BUFER
	call SET_PGT_DATA

	ld de,CT
	ld a,#F1
	ld bc,32
	call FILVRM

	ld de,PNT
	ld a,#00
	ld bc,768
	call FILVRM

	call SCREEN_ON

	
main_loop:
	ei
	halt
	di
NEW_CHR_FLAG:
	ld a,0
	and a
	jr nz,SCROLL_BUFER_FLAG
	inc a
	ld (NEW_CHR_FLAG+1),a
	call GET_CHR				; берем букву из текста и копируем ее паттерн
SCROLL_BUFER_FLAG:
	ld a,0
	and a
	jr nz,$+12
	inc a
	ld (SCROLL_BUFER_FLAG+1),a
	call SCROLL_BUFER			; скролим буфер экрана на 1 знакоместо
	call SCROLL_CHR				; скролим паттерн буквы			

	call CHANGE_FASES
H_FASE_L_BIT_COUNT:
	ld hl,#0808
	dec h
	jr nz,not_end_fases
	ld h,8
	xor a						; все фазы закончились переходим к следующему биту
	ld (SCROLL_BUFER_FLAG+1),a
	ld (FASE_TILE_COUNT+1),a
	dec l
	jr nz,not_end_fases
	ld l,8
	xor a						; все биты обработаны - переходим к следующей букве
	ld (NEW_CHR_FLAG+1),a
not_end_fases:
	ld (H_FASE_L_BIT_COUNT+1),hl	
	jr main_loop

;-------------------------------------------------------------------
GET_CHR:
set_text:
	ld hl,txt_data
	ld a,(hl)
	and a
	jr nz,$+6
	ld hl,txt_data
	ld a,(hl)
	inc hl
	ld (set_text+1),hl
	sub #20
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,fnt_data
	add hl,de

	inc hl

	ld de,CHR_BUFER
	ld bc,6
	ldir
	ret


;--------------------------------------------------------------
CLS_BUFER:
	ld hl,BUFER
	ld de,BUFER+1
	ld bc,256*3-1
	ld (HL),#00
	ldir
	ret
;----------------------------------------------------------------
SET_PGT_DATA:
	ld l,PUSTO_PUSTO
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,PGT
	add hl,de
	ex de,hl
	ld bc,8*8
	ld a,0
	call FILVRM



	ld l,NET_PUSTO
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,PGT
	add hl,de
	ex de,hl
	call SetVdp_Write
	ld a,11111110b
	ld c,8
spgtl2:
	ld b,8
spgtl1:
	out (#98),a
	djnz spgtl1
	sla a
	dec c
	jr nz,spgtl2

	ld l,NET_NET
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,PGT
	add hl,de
	ex de,hl
	ld bc,8*8
	ld a,#FF
	call FILVRM

	ld l,PUSTO_NET
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,PGT
	add hl,de
	ex de,hl
	call SetVdp_Write
	ld a,00000001b
	ld c,8
spgtl4:
	ld b,8
spgtl3:
	out (#98),a
	djnz spgtl3
	sll a
	dec c
	jr nz,spgtl4
	ret	
;--------------------------------------------------------
BUFER				EQU #F000
CHR_BUFER			EQU	BUFER+#0300
FASE_TALE_TABLE		EQU #E000
FIRST_TILE_TABLE	EQU	#8000	; адрес таблицы для начальных тайлов
								; #8000-пусто-пусто
								; #8001-пусто-нет
								; #8101-нет-нет
								; #8100-нет-пусто
PUSTO_PUSTO		EQU	#00		
NET_PUSTO		EQU	#00+8		; точка есть, нет точки
NET_NET			EQU	#00+8+8		; точка есть,точка есть
PUSTO_NET		EQU	#00+8+8+8	; нет точки, точка

pusto_pusto:
	db	00000000b
net_pusto:
	db	11111110b
net_net:
	db	11111111b
pusto_net:
	db	00000001b

SCROLL_CHR:
old:
	ld hl,OLD_BIT
new:
	ld de,NEW_BIT
	exx
	ld bc,BUFER+31
	ld hl,CHR_BUFER
	ld a,6				; сколько строк
ptl:
	push af
	rlc (hl)
	call get_first_tile
	push hl
	push bc
	pop hl
	ld de,32
	ld (hl),a

	add hl,de
	ld (hl),a

	add hl,de
	ld (hl),a

	add hl,de
	ld (hl),a

	add hl,de
	ld b,h
	ld c,l

	pop hl
	inc hl
	pop af
	dec a
	jr nz,ptl
	ld hl,(old+1)
	ld de,(new+1)
	ex de,hl
	ld (old+1),hl
	ld (new+1),de
	ret	
get_first_tile:
	exx
	ld a,0
	adc a,a
	ld (de),a
	ld c,a
	ld a,(hl)
	or high FIRST_TILE_TABLE
	ld b,a
	ld a,(bc)
	inc hl
	inc de
	exx
	ret
OLD_BIT:	db 0,0,0,0,0,0,0,0
NEW_BIT:	db 0,0,0,0,0,0,0,0

SCROLL_BUFER:
	ld hl,BUFER+1
	ld de,BUFER
	ld a,24			; сколько строк
scrbl:
	DUP 31
	ldi
	EDUP
	inc hl
	inc de
	dec a
	jr nz,scrbl
	ret

;--- МЕНЯЕМ ФАЗЫ В БУФЕРЕ И ВЫВОДИМ НА ЭКРАН -----------------
CHANGE_FASES:
	ld hl,PNT
	ld a,l
	out (#99),a
	ld a,h
	or #40
	out (#99),a
FASE_TILE_COUNT:
	ld c,#00
	ld hl,BUFER
	ld b,24						; сколько строк
ftcl:
	DUP 32
	ld a,(hl)
	add c
	out (#98),a
	inc hl;inc l
	EDUP
	dec b
	jp nz,ftcl
	ld a,c
	inc a

	ld (FASE_TILE_COUNT+1),a
	ret
;-------------------------------------------------------------
interrupt_routine:
	di
	push af
    push bc
    push de
    push hl
    push ix
    push iy
    exx
    ex   af,af'
    push af
    push bc
    push de
    push hl
  	in a,(#99)
	pop  hl
    pop  de
    pop  bc
    pop  af
    ex   af,af'
    exx
    pop  iy
    pop  ix
    pop  hl
    pop  de
    pop  bc
    pop  af
    ei
    ret
;------------ SCREEN 1 ----------------------------------
SET_SCREEN1:
	ld hl,reg_data_SCREEN1
    ld a,#00                ; начинаем заполнять данные с регистра #00; bit7=0 - авто инкримент
    out (#99),a
    ld a,#91                ; выбираем рег. 17(#11); bit7=1 write
    out (#99),a
    ld c,#9B                ; выбираем порт 3 VDP (#9B)
    ld b,10                 ; сколько регистров загружаем данными
;$-2
    outi
    jr nz,$-2
	ret
;-------------------------------------------------------------------
reg_data_SCREEN1:
;R0
	db	#00 
;R1
	db	#20 or SPRITE_SIZE
;R2
	db	#06
;R3
	db	#80
;R4
	db	#00
;R5
	db	#36
;R6
	db	#07
;R7
	db	#01
;R8
	db	#08
;R9    Mode register 
	db #02				; PAL - бит 1=1
;---- SCREEN ON ----------------------------------------------
SCREEN_ON:
	ld a,(reg_data_SCREEN1+1)	; data for r1
	or #40
	out (#99),a					; bit6=1 SCREEN ON
	ld a,#81					; reg 1 write
	out (#99),a
	ret	
;---- SCREEN OFF ----------------------------------------------
SCREEN_OFF:
	ld a,(reg_data_SCREEN1+1)	; data for r1
;	or #40
	out (#99),a					; bit6=1 SCREEN ON
	ld a,#81					; reg 1 write
	out (#99),a
	ret
;---------------------------------------------------------------

;--------------------
FILVRM:
	call SetVdp_Write
	ld e,a
FILVRM_loop:
	ld a,e
	out (#98),a
	dec bc
	ld a,c
	or b
	jr nz,FILVRM_loop
	ret
;--------------------
LDIRVM:
	call SetVdp_Write
LDRVRM_loop:
	ld a,(hl)
	out (#98),a
	inc hl
	dec bc
	ld a,c
	or b
	jr nz,LDRVRM_loop
	ret
;---------------------		
SetVdp_Write:			
	ex af,af'
;--- устанавливаем reg 14 -------------------------
;	xor a
;	out (#99),a		; адрес видеопамяти #0000-#FFFF
;	ld a,#8E		; reg 14 + бит7=1(write)
;	out (#99),a
;--------------------------------------------------
    ld a,e			; младший байт адреса
	out (#99),a		;
    ld a,d			; старший байт адреса
    or 64			; бит 6=1(write)
  	out (#99),a
	ex af,af'
    ret
;--------------------------------------------------
	ds	20
newsp:	dw 0
txt_data:	db "FULL SCREEN One pixel side scroll FOR any MSX computer!!!     "
		db	0
fnt_data:
	incbin "hitech.fnt"

